<?php

if (defined("_INC_PUBLIC")) { // inclusion diffre
  $page = inclure_page($fond, $delais, $contexte_inclus);
  if ($page['process_ins'])
    { eval('?' . '>' .  $page['texte']); }
  else
   { 
     echo $page['texte']; 
   }
 } else { // premier appel
  define("_INC_PUBLIC", "1");
  include ("ecrire/inc_version.php3");
  if ($INSECURE['fond'] || $INSECURE['delais']) exit;
  if (!isset($delais)) $delais = 1 * 3600;
  if ($HTTP_COOKIE_VARS['spip_session'] OR ($PHP_AUTH_USER AND !$ignore_auth_http)) {
       include_ecrire ("inc_session.php3");
       verifier_visiteur();
 }
 
 //
 // Gestion de la langue dans l'URL
 //
 if ($forcer_lang) {
       include_ecrire('inc_lang.php3');
       verifier_lang_url();
 }
 if ($lang = $HTTP_GET_VARS['lang']) {
       include_ecrire('inc_lang.php3');
       lang_select($lang);     
    }

include_ecrire("inc_meta.php3");

// ajout_forum est une HTTP_GET_VAR installe par retour_forum dans inc-forum.
// Il s'agit de pirater les HTTP_POST_VARS, afin de mettre en base
// les valeurs transmises, avant raffichage du formulaire avec celles-ci.
// En cas de validation finale a redirige vers l'URL ayant provoqu l'appel
// au lieu de laisser l'URL appele resynthtiser le formulaire.

  if ($ajout_forum) {
    $redirect = '';
    include('inc-messforum.php3');
    if ($redirect)
      {
	header("Location: $redirect");
	exit();
      }
  }
  include_local ("inc-public-global.php3");
  include_local ("inc-cache.php3");
  $cle = nom_du_cache($fond, $HTTP_GET_VARS);
  $headers_only = $HTTP_SERVER_VARS['REQUEST_METHOD'];
  spip_log("$headers_only $HTTP_IF_MODIFIED_SINCE $GLOBALS[PHP_SELF]");
  $headers_only  = ($headers_only == 'HEAD');
  $lastmodified = 0;
  if ($headers_only || $HTTP_IF_MODIFIED_SINCE)
    {
      $lastmodified = cv_du_cache($cle, $delais);
      $gmoddate = gmdate("D, d M Y H:i:s", $lastmodified);
      // Code inoprant si le serveur HTTP traite ce champ en amont.
     if ($HTTP_IF_MODIFIED_SINCE)
       {
	 $if_modified_since = ereg_replace(';.*$', '', $HTTP_IF_MODIFIED_SINCE);
	 if (trim(str_replace('GMT', '', $if_modified_since)) == $gmoddate) {
	   http_status(304);
	   $headers_only = true;
	 }
       }
    }
  
  if ($headers_only)
   {
     header("Last-Modified: ".$gmoddate." GMT");
     header("Connection: close");
     spip_log("Close, lastmodified: $lastmodified");
   }
  else
   {
     $page = ramener_cache($cle,
			   'cherche_page_incluante', 
			   array('fond' => $fond,
				 'var_recherche' => $var_recherche),
			   &$delais);
     $lastmodified = $page['naissance'];
     // interdire au client de cacher un login, un admin ou un recalcul
     if (!$flag_dynamique && $recalcul != 'oui' && !$HTTP_COOKIE_VARS['spip_admin'])
       $expire = gmdate("D, d M Y H:i:s", $lastmodified + $delais)." GMT";
     else {
       $expire = "0";
       Header("Cache-Control: no-cache,must-revalidate");
       Header("Pragma: no-cache");
     }
     Header("Expires: $expire");
     Header("Last-Modified: ".
	    gmdate("D, d M Y H:i:s", 
		   ($lastmodified ? $lastmodified : time())) .
	    " GMT");
     Header("Content-Type: text/html; charset=".lire_meta('charset'));
 
     $texte = admin_page($page['texte'], $lastmodified);
     if ($page['process_ins'] == 'php')
       eval('?' . '>' . $texte);
     else
       { 
	 $n = strlen($texte);
# L'envoi du content-Length ci-dessous permet d'envoyer d'autres rponses
# dans le cadre des connexions persistantes de HTTP1
# Elle doit s'accompagner du connection-close sinon
# elle retarde l'affichage de certains navigateurs.
# On l'a dsactiv ici puisqu'il n'y a qu'une seule rponse, 
# et que certains serveurs la calculent et maintiennent la connexion
# header("Content-Length: " . $n);
# header("Connection: close");
	 echo $texte; 
	 spip_log("Page 100% HTML (" . $n  . " octets)");
       }
   }

# Toutes les heures, menage d'un cache si le processus n'a rien recalcul.
# On nettoie celui de la page retourne car le systme vient d'y accder:
# il l'a toujours dans son cache si on n'a pas t prempt

  if ($lastmodified && (time() - lire_meta('date_purge_cache') > 3600))
   {
     ecrire_meta('date_purge_cache', time());
     retire_vieux_caches($cle, $delais);
   }

# Mise a jour des fichiers langues de l'espace public

if ($cache_lang_modifs) {
	include_ecrire('inc_lang.php3');
	ecrire_caches_langues();
}
# demander l'indexation de ce qu'on vient d'envoyer


 if ((lire_meta('activer_moteur') == 'oui') && $db_ok) {
  if ($id_article AND (1 >= spip_num_rows(spip_query("
SELECT	id_article
FROM	spip_index_articles 
WHERE	id_article=$id_article
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('article', $id_article);
    }
  else { if ($id_auteur AND (1 >= spip_num_rows(spip_query("
SELECT	id_auteur
FROM	spip_index_auteurs
WHERE	id_auteur=$id_auteur
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('auteur', $id_auteur);
    }
  else { if ($id_breve AND (1 >= spip_num_rows(spip_query("
SELECT	id_breve
FROM	spip_index_breves
WHERE	id_breve=$id_breve
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('breve', $id_breve);
    }
  else { if ($id_mot AND (1 >= spip_num_rows(spip_query("
SELECT	id_mot
FROM	spip_index_mots
WHERE	id_mot=$id_mot
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('mot', $id_mot);
    }
  else { if ($id_rubrique AND (1 >= spip_num_rows(spip_query("
SELECT	id_rubrique
FROM	spip_index_rubriques
WHERE	id_rubrique=$id_rubrique
LIMIT 2
"))))
    {
      include_ecrire("inc_index.php3");
      indexer_objet('rubrique', $id_rubrique); 
    }
  }}}}}

# en cas de recalcul ou de mnage, pas assez de temps pour les tache de fond,
# d'autant que le client s'impatiente sans connexion-close

  if (!$lastmodified) exit();

  include_ecrire("inc_cron.php3");
 }
 // fin du defined
?>
